/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package dpop;

import java.util.*;

/**
 *
 * @author Andrea
 */
public class NAryConstraint implements Constraint {
    //the object can be a Value (1-ary constraint) or another
    //TaggedDictionary<couple, object>
    private TaggedDictionary<Couple, Object> _constraint;

    NAryConstraint() {
        _constraint = new TaggedDictionary<Couple, Object>();
    }

    NAryConstraint(TaggedDictionary<Value, Object> util) {
        _constraint = _compute_util(util);
    }

    private TaggedDictionary<Couple, Object> _compute_util(TaggedDictionary<Value, Object> util) {
        TaggedDictionary<Couple, Object> res = new TaggedDictionary<Couple, Object>();
        Object new_dimension = util;

        PseudoTreeNode n = (PseudoTreeNode)util.getTag();

        //searches the occurence of n in couples and takes its value
        Iterator<Value> it = util.keySet().iterator();
        while (it.hasNext()) {
            Value current = it.next();
            Couple c = new Couple(n, current);
            new_dimension = util.get(current);

            if (new_dimension instanceof Value) {
                res.put(c, new_dimension);
            }
            else {
                res.put(c, _compute_util((TaggedDictionary<Value, Object>)new_dimension));
            }

        }

        return res;
    }

    public Value getConstraint(Couple[] couples) {
        Value v;

        TaggedDictionary<Couple, Object> current_dimension = _constraint;
        Object new_dimension = current_dimension;

        while (new_dimension instanceof TaggedDictionary) {
            current_dimension = (TaggedDictionary<Couple, Object>)new_dimension;
            Variable n = current_dimension.keySet().iterator().next().getKey();

            //searches the occurence of n in couples and takes its value
            for (int i = 0; i < couples.length; i++) {
                Couple current = couples[i];
                Variable current_node = current.getKey();
                if (n.equals(current_node)) {
                    new_dimension = current_dimension.get(current);

                    break;
                }
            }
        }

        return (Value)new_dimension;
    }

    public ArrayList<Variable> getVariables() {
        ArrayList<Variable> res = new ArrayList<Variable>();

        TaggedDictionary<Couple, Object> current_dimension = _constraint;
        Object new_dimension = current_dimension;

        while (new_dimension instanceof TaggedDictionary) {
            current_dimension = (TaggedDictionary<Couple, Object>)new_dimension;
            Couple c = current_dimension.keySet().iterator().next();
            Variable n = c.getKey();
            res.add(n);
            new_dimension = current_dimension.get(c);
        }

        return res;
    }

}
