/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package dpop;
import java.util.*;
import java.lang.*;
import java.io.*;

/**
 *
 * @author Andrea
 */
public class Couple implements Map.Entry<Variable, Value> {
    Variable _node;
    Value _value;

    Couple(Variable n, Value v) {
        _node = n;
        _value = v;
    }

    public Variable getKey() {
        return _node;
    }

    public Value getValue() {
        return _value;
    }

    public Value setValue(Value value) {
        Value prev = _value;
        _value = value;
        return prev;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Couple other = (Couple) obj;
        if (this._node != other._node && (this._node == null || !this._node.equals(other._node))) {
            return false;
        }
        if (this._value != other._value && (this._value == null || !this._value.equals(other._value))) {
            return false;
        }
        return true;
    }

    @Override
    public int hashCode() {
        int hash = 5;
        hash = 41 * hash + (this._node != null ? this._node.hashCode() : 0);
        hash = 41 * hash + (this._value != null ? this._value.hashCode() : 0);
        return hash;
    }
}
